/**
 * 
 */
package sample.auction;

import sample.auction.behaviours.AuctioneerBehaviour;
import jade.core.Agent;
import jade.domain.DFService;
import jade.domain.FIPAException;
import jade.domain.FIPAAgentManagement.DFAgentDescription;
import jade.domain.FIPAAgentManagement.ServiceDescription;

/**
 * @author tdoi
 *
 */
public class AuctioneerAgent extends Agent {

	/**
	 * 
	 */
	private static final long serialVersionUID = -3586156885636517637L;

	/**
	 * 
	 */
	public AuctioneerAgent() {
	}

	protected void setup() {
		try {
			registerWithDF();
		} catch (FIPAException e) {
			e.printStackTrace();
			
			return;
		}
		
		addBehaviour(new AuctioneerBehaviour(this));
		super.setup();
	}
	
	private void registerWithDF() throws FIPAException {
	    ServiceDescription sd = new ServiceDescription();
	    sd.setName("EnglishAuction");
	    sd.setType("Auctioneer");
	    sd.addOntologies("english-auction-ontology");
	    DFAgentDescription dfd = new DFAgentDescription();
	    dfd.setName(getAID());
	    dfd.addServices(sd);
	    dfd.addOntologies("pa-ontology");
	    dfd.addProtocols("fipa-request fipa-Contract-Net");

	    DFService.register(this, dfd);
	}

}
