/**
 * 
 */
package sample.auction;

import sample.auction.behaviours.BidderBehaviour;
import jade.core.Agent;
import jade.domain.DFService;
import jade.domain.FIPAException;
import jade.domain.FIPAAgentManagement.DFAgentDescription;
import jade.domain.FIPAAgentManagement.ServiceDescription;

/**
 * @author tdoi
 *
 */
public class BidderAgent extends Agent {

	/**
	 * 
	 */
	private static final long serialVersionUID = -4069149962022142308L;

	/**
	 * 
	 */
	public BidderAgent() {

	}

	protected void setup() {
		try {
			registerWithDF();
		} catch (FIPAException e) {
			e.printStackTrace();

			return;
		}
		
		addBehaviour(new BidderBehaviour(this));
		super.setup();
	}
	
	private void registerWithDF() throws FIPAException {
	    ServiceDescription sd = new ServiceDescription();
	    sd.setName("EnglishAuction");
	    sd.setType("Bidder");
	    sd.addOntologies("ea-ontology");
	    DFAgentDescription dfd = new DFAgentDescription();
	    dfd.setName(getAID());
	    dfd.addServices(sd);
	    dfd.addOntologies("ea-ontology");
	    dfd.addProtocols("english-auction");

	    DFService.register(this, dfd);
	}

}
