/**
 * 
 */
package sample.auction.behaviours;

import jade.core.Agent;
import jade.core.behaviours.Behaviour;
import jade.lang.acl.ACLMessage;

/**
@*@rb_[G[WFgBehaviour
 */
public class BidderBehaviour extends Behaviour {

	private static final long serialVersionUID = -1314576159273714092L;

	/** G[WFg̓̏Ԃ̒` */
	private static final int INITIAL  = 0;
	private static final int WAIT_CFP = 1;
	private static final int WAIT_RES = 2;
	private static final int FINISH   = 3;
	
	/** G[WFg̓̏ */
	private int state_ = INITIAL;
	/** G[WFg̓̏ItO */
	private boolean done_ = false;
	/** G[WFg̓ɂāAG[ǂ̃tO */
	private boolean fail_ = false;

	/** ݂CFP̉i */
	private int currentOffer_ = -1;
	/** ݂CFPbZ[W */
	private ACLMessage cfp_ = null;
	
	/**
	 * RXgN^
	 * @param agent
	 */
	public BidderBehaviour(Agent agent) {
		super(agent);
	}

	/**
	 * Behaviour̓̒`
	 */
	public void action() {
		switch (state_) {
		case INITIAL:
			if (waitBegining()) {
				state_ = WAIT_CFP;
			}
			break;
		case WAIT_CFP:
			int type = waitCfp();
			switch (type) {
			case 0:
				state_ = WAIT_CFP; // p
				break;
			case 1:
				doBid();
				state_ = WAIT_RES;
				break;
			case -1:
				state_ = FINISH;
				break;
			}
			break;
		case WAIT_RES:
			if (waitResponse()) {
				state_ = WAIT_CFP;
			}
			break;
		case FINISH:
			done_ = true;
			break;
		}
	}
	

	/**
	 * Is
	 * @return I[NVIA܂́AsĂΏIƔ肷
	 */
	public boolean done() {
		return done_ || fail_;
	}

	/**
	 * I[NVJn̂҂
	 * @return I[NV̊Jnʒm󂯎truełȂfalseԂ
	 */
	private boolean waitBegining() {
		ACLMessage msg = myAgent.receive();
		if (msg == null) {
			// M̂߁AM҂
			block();
			return false;
		}
		
		// I[NVJnbZ[Wǂ`FbN
		if (msg.getPerformative() != ACLMessage.INFORM && msg.getContent() != "begin") {
			// sȃbZ[WM߁AI
			fail_ = true;
			
			return false;
		}
		
		return true;
	}
	
	/**
	 * I[NVjACFPA܂́AI[NV̏Iʒm҂B
	 * @return CFPMł΂PԂB܂AI[NV̏Iʒm󂯎΁A-1ԂBǂMȂ΁A0ԂB
	 */
	private int waitCfp() {
		ACLMessage msg = myAgent.receive();
		if (msg == null) {
			// M̂߁AM҂
			block();
			return 0;			
		}

		int performative = msg.getPerformative(); 
		switch (performative) {
		case ACLMessage.CFP: // CFPM̂ŁA ݂̉i擾
			currentOffer_ = Integer.parseInt(msg.getContent());
			cfp_ = msg;
			return 1;
		case ACLMessage.INFORM: // IʒmM
			return -1;
		default: // sȃbZ[WM߁AI
			fail_ = true;
			return 0;
		}
	}
	
	/**
	 * rbhs
	 */
	private void doBid() {
		int price = currentOffer_ + (int)(Math.random() * 1000);
		ACLMessage bid = cfp_.createReply();
		bid.setContent(String.valueOf(price));
		myAgent.send(bid);		
	}
	
	/**
	 * rbhɑ΂郌X|X҂
	 * @return X|XMłtrueAłȂfalseԂB
	 */
	private boolean waitResponse() {
		ACLMessage msg = myAgent.receive();
		if (msg == null) {
			// M̂߁AM҂
			block();
			return false;			
		}
		
		int performative = msg.getPerformative();
		if (performative != ACLMessage.ACCEPT_PROPOSAL &&
			performative != ACLMessage.REJECT_PROPOSAL) {
			
			fail_ = true;
			return false;
		}

		return true;
	}

}
